/* Krister Swenson                                                  Spring 2006

Print the permutations that are SEQLEN long with (SEQLEN+1)/2 cycles of length
four (reduced permutations) that yeild an sorting lattice island of
size (SEQLEN+1)/2.
*/

#include <iostream>
#include "../graph/med.h"
#include "../seqtools/latticefuncs.h"


using namespace std; 

#define SEQLEN 9

void printList(vector<int> &L);
void findislands(vector<int> seq, vector<int> L);


int COUNT=0;


int main()
  {
  vector<int> vals;
  for(int i=1; i<=SEQLEN; i++)
    vals.push_back(i);

  vector<int> seq;
  findislands(seq, vals);
  cerr << "done. " << COUNT << " permutations checked." << endl;

  return(0);
  }




//\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\__/\_


void findislands(vector<int> seq, vector<int> L)
  {
  if(L.empty())
    { 
    Ograph gr(seq);
    if(gr.getDistNH() == (SEQLEN+1)/2)
      {
      COUNT++;
      if(hasIsland(gr))
        {
        gr.printSeqStr();
        cerr << endl;
        }
      }
    } 

  for(vector<int>::iterator i = L.begin(); i != L.end(); i++)
    {
    int temp = *i;
    vector<int>::iterator j = L.erase(i);

    if(seq.empty() || (temp-*seq.rbegin() != 1)) //If it's a breakpoint
      {
      if(!(seq.empty() && temp == 1) && !(L.empty() && temp == SEQLEN))
        {
        seq.push_back(temp);                        //add it to the sequence
        findislands(seq, L);                        //and recurse.
        seq.pop_back();
        }
      }
    if(seq.empty() || (-temp-*seq.rbegin() != 1))//If it's a breakpoint
      {
      temp *= -1;
      seq.push_back(temp);                        //add it to the sequence
      findislands(seq, L);                        //and recurse.
      seq.pop_back();
      }

    L.insert(j, temp);
    }
  }


/* Print the given list to stderr.
*/
void printList(list<int> &L)
  {
  list<int>::iterator i = L.begin();

  cerr << *i++;
  while(i != L.end())
     cerr << " " << *i++;
  }


