//Krister Swenson                                                  Spring 2008
//
//Reads in one sequences containing and prints the distance from the ID using
// the O(n lg(n)) method.
//

#include <iostream>
#include "Permutation.h"
#include "../seqtools/seqfuncs.h"

//Find the full sorting path even when encountering unsafe inversions:
//  (otherwise just fail and do restart depending on the value of RESTARTS)
#define FIX_UNSAFE

//Should be one of RANDOM, USE_MAX, or USE_MIN:
#define METHOD USE_MIN
//If one side is unsafe, then do the other:
// #define TRY_OTHER_ON_FAILURE

// #define PRINT_REVS    //Print the reversals that have been done.

int main()
  {
  int* seq;
  cout << "seq:";
  int lseq = getInputSeq(&seq);
  assert(validPerm(seq, lseq));

  Permutation p(seq, lseq);
/*
  if(p.hasHurdle())
    {
    cerr << "Input permutation has a hurdle in it!" << endl;
    exit(0);
    }
*/
  vector<int> qv = p.getSeqVec();


  list<ipair> revs;
#ifdef FIX_UNSAFE
  revs = p.getSortSeq(METHOD);
#else
  ipair rev;
  while(p.nextRev(rev, METHOD))
    revs.push_back(rev);
#endif

#ifdef PRINT_REVS
  cout << "reversals done:" << endl;
  for(list<ipair>::iterator i=revs.begin(); i!=revs.end(); i++)
    cout << *i << " ";
  cout << endl;
#endif

            //Check the sorting path:
  for(list<ipair>::iterator i=revs.begin(); i!=revs.end(); i++)
    applyRev(qv,*i);
  cout << "dist:" << revs.size() << endl;
  cout << "dist:" << getLinearTimeDist(seq, lseq) << endl;
  if((int)revs.size() != getLinearTimeDist(seq, lseq))
    {
    cerr << "Not sorted:\n\t" << p << endl;
    return 0;
    }

  assert(getLinearTimeDist(qv) == 0);

  free(seq);

  return 0;
  }
