/* Krister Swenson                                            Spring 2003

A component has a list of boolean values for every cycle.  The true values
  indicate membership of this component.  A component can be good or bad.
*/

#include "Component.h"

using namespace std; 


Component::Component(int cycles)
  {
  good = false;
  cyclenum = cycles;
  members = new bool[cyclenum];
  for(int i=0; i < cyclenum; i++)
    members[i] = false;
  }

void Component::operator=(const Component& c)
  {
  delete [] members;
  copy(c);
  }

Component::Component(const Component& c)
  {
  copy(c);
  }

void Component::copy(const Component& c)
  {
  cyclenum = c.cyclenum;
  good = c.good;

  members = new bool[cyclenum];
  for(int i=0; i < cyclenum; i++)
    members[i] = c.members[i];
  }

Component::~Component()
  {
  //cerr << this <<endl;
  //fprintf(stderr, "freeComp %x\n", members);
  delete [] members;
  }




/*Mark this cycle as being good.
*/
void Component::makeGood()
  { good = true; }

/*Return true if this is a good component.
*/
bool Component::isGood()
  { return good; }


/*Mark -cycle- as being part of this component.
*/
void Component::makeMember(int cycle)
  { members[cycle] = true; }


ostream& operator<<(ostream& output, Component& c)
  {
  output << "Component: ";
  for(int i=0; i < c.cyclenum; i++)
    if(c.members[i])
      output << i << " ";

  output << "good:" << c.good;

  return output;
  }
