/*  Krister Swenson                                        Fall 2002
*/

#include "Cycle.h"

using namespace std; 


//------------------------ Constructors etc -----------------------
/* Create a Cycle.
*/
Cycle::Cycle()
  {
  good = true;        //Assume the cycle is GOOD until there are three nodes.
  del = false;
  }

Cycle::~Cycle()
  {}

Cycle::Cycle(const Cycle& c)
  { copy(c); }

void Cycle::operator=(const Cycle& c)
  { copy(c); }

void Cycle::copy(const Cycle& c)
  {
  good = c.good;
  del = c.del;

  nodes = c.nodes;
  permnums = c.permnums;
  }

void Cycle::clear()
  {
  good = true;
  del = false;
  nodes.clear();
  permnums.clear();
  }

//-----------------------------------------------------------------

void Cycle::add(int node, int permnum)
  {
  nodes.push_back(node);
  permnums.push_back(permnum);
  if(nodes.size() == 3)
    good = false;  //Assume the cycle is BAD now that we have three nodes.
  }

/*Get the beginning of the node list.
*/
vector<int>::iterator Cycle::getBeg()
  { return nodes.begin(); }
/*Get the end of the node list.
*/
vector<int>::iterator Cycle::getEnd()
  { return nodes.end(); }
/*Get the ith member of -permnums-.
*/
int Cycle::getPermNum(int i)
  { return permnums[i]; }
/*Get the ith member of -nodes-.
*/
int Cycle::getNodeNum(int i)
  { return nodes[i]; }


void Cycle::print() const
  {
  fprintf(stderr, "__\n");
  for(unsigned int i=0; i < nodes.size(); i++)
    cerr << nodes[i] << " ";
  }

bool Cycle::getGood() const
  { return good; }

void Cycle::setGood(bool g)
  { good = g; }


void Cycle::printNodes(ostream& output) const
  {
  if(good)
    output << "GOOD: ";
  else
    output << "BAD: ";

  for(unsigned int i=0; i < nodes.size(); i++)
    {
    if(i%2 == 0)
      output << nodes[i] << "-";
    else
      output << nodes[i] << "^";
    }
  }

ostream& operator<<(ostream& output, const Cycle& c)
  {
  if(c.good)
    output << "GOOD: ";
  else
    output << "BAD: ";

  for(unsigned int i=0; i < c.nodes.size(); i++)
    {
    if(i%2 == 0)
      output << c.permnums[i] << "-";
    else
      output << c.permnums[i] << "^";
    }

  return output;
  }

/* Return true if this has an associated deletion.  Reset the cycle's value.
  ** Temporary
*/
bool Cycle::getDel()
  {
  if(del)
    {
    del = false;
    return true;
    }

  return del;
  }

int Cycle::getSize() const
  { return nodes.size(); }

/*Say that this cycle has an associated deletion.  ** Temporary
*/
void Cycle::setDel()
  { del = true; }

