/*  Krister Swenson                                        Fall 2002
*/

#include "Pair.h"


using namespace std; 


//------------------------ Constructors etc -----------------------
Pair::Pair()
  {
  left = 0;
  right = 0;
  }

/* Create a Pair with the given left and right.
*/
Pair::Pair(int v1, int v2)
  {
  left = v1;
  right = v2;
  }

Pair::Pair(const pair<int,int> &p)
  {
  left = p.first;
  right = p.second;
  }

Pair::~Pair()
  {}

Pair::Pair(const Pair& i)
  { copy(i); }

void Pair::operator=(const pair<int,int>& p)
  { left = p.first; right = p.second; }
  
void Pair::operator=(const Pair& i)
  { copy(i); }

bool Pair::operator==(const pair<int,int>& p) const
  { return ((left == p.first) && (right == p.second)); }

bool Pair::operator==(const Pair& i) const
  { return ((left == i.left) && (right == i.right)); }

bool Pair::operator!=(const Pair& i) const
  { return ((left != i.left) || (right != i.right)); }

bool Pair::operator!=(const pair<int,int>& p) const
  { return ((left != p.first) || (right != p.second)); }

bool Pair::operator<(const Pair& p) const
  {
  if(left < p.left)
    return true;
  return left == p.left && right < p.right;
  }
bool Pair::operator>(const Pair& p) const
  {
  if(left > p.left)
    return true;
  return left == p.left && right > p.right;
  }

//Cast a Pair to and integer pair.
Pair::operator pair<int,int>() const
  { return pair<int,int>(left, right); }

bool Pair::overlaps(const Pair& p) const
  {
  if(left == p.left || right == p.right)
    return false;
  else if(left < p.left && (right < p.left || right > p.right))
    return false;
  else if(left > p.right)
    return false;
  else if(right < p.right)
    return false;

  return true;
  }



int Pair::size() const
  { return left - right+1; }


void Pair::copy(const Pair& i)
  {
  left = i.left;
  right = i.right;
  }

//-----------------------------------------------------------------

int Pair::getLeft() const
  { return left; }

int Pair::getRight() const
  { return right; }

void Pair::set(int l, int r)
  { left = l; right = r; }


ostream& operator<<(ostream& output, const Pair& i)
  {
  output << "[" << i.left << " " << i.right << "]";

  return output;
  }
