#ifndef INS_SELECTION
#define INS_SELECTION

//This file provides the method to pick the best insertion locations given
//the information in the possible
//clumping matrix.

#ifdef _MSC_VER
#pragma warning (disable : 4503) // Turn off dumb Visual C++ warning
#endif

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include "../multi/SortSeq.h"	// globalSortSequence

//here we have a bunch of helper functions to do subset cover
//our sets will be arrays whose first element is the cardinality of the set.
void  insLocs(int** insMatrix, int rows, int columns, int* numIns);

/*** LOCAL FUNCTIONS ***
int** getSubSets(int** insMatrix, int rows, int columns);
int* makeSet(int* elems, int card);
int member(int elem, int* Set); //returns the index that elem is at 0 if not present
void removeElem(int* Set, int elem);
void setDiff(int* s1, int* s2); //return s1 - s2 mutating s1
int compareSetCard(int* s1, int* s2); //return 1 iff |s1| >= |s2|
int isEmpty(int* Set);
int* getMaxSet(int** sets, int numSets, int* loc);
void stripVals(int* Set, int** allSets, int numSets); //for all s in allSets do s - set
************************/

#endif
