/* Krister Swenson                                                  Spring 2006

Find a set of mutually (for both permutations) maximum noninterfering
inversions.
*/

#include <iostream>
#include <vector>
#include "../graph/med.h"
#include "../graph/Pair.h"
#include "../seqtools/seqfuncs.h"

using namespace std; 




int main()
  {
  int *s1=0;
  int *s2=0;

  cout << "seq1:";
  int s1len = getInputSeq(&s1);
  cout << "seq2:";
  int s2len = getInputSeq(&s2);

  if(s1len != s2len)
    {
    cerr << "The Length of the permutations don't match: "
         << s1len << "," << s2len << endl;
    return(1);
    }

  Ograph g(s1, s1len);             //Build the graph for s1.
  Ograph g2(s2, s2len);            //Build the graph for s2.

      //Find a maximum independant set of noninterfering inversions.
  list<Pair> nmis = g.getMutualNonintMIS(g2);
  cout << "noninterfering MIS: " << nmis << endl;
  cout << nmis.size() << "/" << g.getDistNH() << " sorted.\n";
  cout << nmis.size() << "/" << g2.getDistNH() << " sorted.\n";
  Ograph id(makeIDv(s1len));
  id.applyCommutingSet(nmis,true); //Apply the commuting set of unsorting invs.
  cout << "signature:" << id.getSeqString() << endl;
  assert(g.isNonint(nmis));
  assert(g2.isNonint(nmis));

  free(s1);
  free(s2);
  return(0);
  }
