/* Krister Swenson                                                  Fall 2008

Test the algorithm for sorting ternary permutations by transpositions.
*/

#include <assert.h>
#include "../graph/Ograph.h"
#include "seqfuncs.h"


#define REPS 1000

using namespace std; 

vector<int> getTernaryPerm(int len);

int main()
  {
  cout << "Length: ";
  int len;
  cin >> len;

  srandom((unsigned int)time(NULL));
  int reps = 0;
  while(reps < REPS)
    {
    cout << ".";
    vector<int> perm = getTernaryPerm(len);
    Ograph g = Ograph(perm);
    int dist=0;
    while(g.notSorted())
      {
      if(!g.doTwoSplitTrans())
        {
        cerr << endl << "hurdle: " << g.getSeqVec() << endl;
        cerr << "from:   " << perm << endl;
        return(1);
        }
      dist++;
      }
    if(dist != len/2)
      {
      cerr << dist << endl;
      return(1);
      }
    //reps++;
    }

  cout << endl;
  return(0);
  }


/* Return a permutation constructed from doing traspositions that merge
three cycles.
*/
vector<int> getTernaryPerm(int len)
  {
  Ograph p = Ograph(len);
  int dist = 0;
  while(p.doThreeMergeTrans())
    dist++;
  if(dist != len/2)
    {
    cerr << "created distance wrong:" << dist << endl;
    exit(1);
    }
  return p.getSeqVec();
  }
