/* Krister Swenson                                                  Spring 2006

Print a largest signature between the two given sequences
(with the identity as the implicit third).
*/

#include "sigfuncs.h"
#include "../seqtools/seqfuncs.h"

using namespace std; 



int main()
  {
  int *s1=0, *s2=0;
  int s1len = getInputSeq(&s1);
  int s2len = getInputSeq(&s2);

  assert(s1len == s2len);

  Ograph g1(s1, s1len);      //Build the graph for s1.
  Ograph g2(s2, s2len);      //Build the graph for s2.

  Ograph id(makeID(s2len), s2len); //Build the identity graph.

  Ograph deepest;
  deepest = getSig(g1, g2, id);

  cout << "size:" << deepest.getDistNH() << endl;
  cout << "seq: " << deepest.getSeqString() << endl;

  free(s1);
  free(s2);
  return(0);
  }
