/* Krister Swenson                                                 Winter 2007-8

Excercise the graph class.
*/

#include <vector>
#include "Graph.h"
#include "tools.h"

#include <stdlib.h>     //For using igraph:
#include "/usr/include/igraph/igraph.h"
/*
extern "C"
  {
  #include "/usr/include/igraph/igraph.h"
  }
*/


using namespace std; 






int main()
  {
  Graph g;

/*____________________________ Circle Graph Tests ______________________________
//5 Wheel (not a CG):
  g.addEdge(120,121);
  g.addEdge(120,122);
  g.addEdge(120,123);
  g.addEdge(120,124);
  g.addEdge(120,125);
  g.addEdge(121,122);
  g.addEdge(122,123);
  g.addEdge(123,124);
  g.addEdge(124,125);
  g.addEdge(121,125);
//3 Skip Wheel (not a CG):
  g.addEdge(120,121);
  g.addEdge(120,123);
  g.addEdge(120,125);
  g.addEdge(121,122);
  g.addEdge(122,123);
  g.addEdge(123,124);
  g.addEdge(124,125);
  g.addEdge(125,126);
  g.addEdge(121,126);
//7 Wheel (not a CG):
  g.addEdge(120,121);
  g.addEdge(120,122);
  g.addEdge(120,123);
  g.addEdge(120,124);
  g.addEdge(120,125);
  g.addEdge(120,126);
  g.addEdge(120,127);
  g.addEdge(121,122);
  g.addEdge(122,123);
  g.addEdge(123,124);
  g.addEdge(124,125);
  g.addEdge(125,126);
  g.addEdge(126,127);
  g.addEdge(121,127);

//GRAPH1:
  g.addEdge(100,103);
  g.addEdge(100,101);
  g.addEdge(100,102);
  g.addEdge(101,102);
  g.buildBipartite(103,105, 106,110);
  g.addEdge(108,109);
//GRAPH1~:
  g.buildBipartite(80,82, 83,87);
  g.addEdge(88,80);
  g.addEdge(88,89);
  g.addEdge(88,90);
  g.addEdge(89,90);
  g.addEdge(85,86);
//GRAPH2:
  g.addEdge(74,73);
  g.addEdge(75,73);
  g.addEdge(76,73);
  g.addEdge(77,73);
  g.addEdge(78,73);
  g.addEdge(79,73);
  g.addEdge(70,74);
  g.addEdge(70,71);
  g.addEdge(72,71);
  g.addEdge(72,73);
  g.addEdge(71,76);
//GRAPH3:
  g.buildBipartite(60,62, 65,66);
  g.addEdge(60,69);
  g.addEdge(61,69);
  g.addEdge(62,69);
  g.addEdge(62,60);
  g.addEdge(62,61);
  g.addEdge(63,64);
  g.buildBipartite(63,64, 65,66);
  g.addEdge(66,67);
  g.addEdge(66,68);
  g.addEdge(65,68);
  g.addEdge(67,68);
//GRAPH 4:
  g.addEdge(57,59);
  g.addEdge(56,59);
  g.addEdge(58,59);
  g.addEdge(58,57);
  g.buildBipartite(51,52, 56,57);
//GRAPH 5:
  g.addEdge(110,111);
  g.addEdge(110,112);
  g.addEdge(110,113);
  g.addEdge(110,114);
//GRAPH 6:
  g.addEdge(130,132);
  g.addEdge(130,133);
  g.addEdge(130,136);
  g.addEdge(130,137);
  g.addEdge(132,133);
  g.addEdge(132,134);
  g.addEdge(133,135);
  g.addEdge(134,135);
  g.addEdge(134,137);
  g.addEdge(135,136);
  g.addEdge(136,137);


//FROM PAPERS:
//GRAPH from spinrad:
  g.addEdge(41,43);
  g.addEdge(41,44);
  g.addEdge(41,42);
  g.addEdge(44,43);
  g.addEdge(44,42);
  g.buildBipartite(43,44, 45,47);
  g.buildBipartite(45,46, 48,49);
  g.addEdge(47,49);
//FIG1 from gavril (no splits):
  g.addEdge(1,0);
  g.addEdge(2,1);
  g.addEdge(3,2);
  g.addEdge(4,3);
  g.addEdge(4,0);
  g.addEdge(5,3);
  g.addEdge(5,1);
  g.addEdge(5,0);
//FIG4 from gavril:
  g.addEdge(31,32);
  g.addEdge(31,33);
  g.addEdge(31,34);
  g.addEdge(31,35);
  g.addEdge(34,35);
  g.addEdge(34,36);
  g.addEdge(33,32);
  g.addEdge(33,35);
  g.addEdge(33,36);
  g.addEdge(32,36);
  g.addEdge(32,35);
  g.addEdge(36,35);
//FIG5 from gavril:
  g.addEdge(21,25);
  g.addEdge(21,28);
  g.addEdge(22,25);
  g.addEdge(22,28);
  g.addEdge(23,24);
  g.addEdge(23,25);
  g.addEdge(24,25);
  g.addEdge(24,26);
  g.addEdge(24,27);
  g.addEdge(26,28);
  g.addEdge(27,28);
//FIG1 from duran:
  g.addEdge(11,12);
  g.addEdge(11,14);
  g.addEdge(11,15);
  g.addEdge(14,15);
  g.addEdge(12,15);
  g.addEdge(13,12);
  g.addEdge(13,14);
  g.addEdge(13,15);
//FIG1 from supowit:
  g.addEdge(1,0);
  g.addEdge(1,0);
  g.addEdge(3,0);
  g.addEdge(3,2);
  g.addEdge(4,3);
  g.addEdge(4,2);
  g.addEdge(5,3);
  g.addEdge(5,4);
  g.addEdge(5,0);
//FIG1 from valiente (no split):
  g.addEdge(1,2);
  g.addEdge(1,3);
  g.addEdge(1,4);
  g.addEdge(2,1);
  g.addEdge(2,6);
  g.addEdge(2,7);
  g.addEdge(3,1);
  g.addEdge(3,4);
  g.addEdge(3,5);
  g.addEdge(4,1);
  g.addEdge(4,3);
  g.addEdge(4,5);
  g.addEdge(4,6);
  g.addEdge(5,3);
  g.addEdge(5,4);
  g.addEdge(5,6);
  g.addEdge(5,7);
  g.addEdge(6,2);
  g.addEdge(6,4);
  g.addEdge(6,5);
  g.addEdge(7,2);
  g.addEdge(7,5);

  cout << g;
  cerr << "DOW:" << g.getCM() << endl;
  if(!g.isCG())
    cerr << "Not a circle graph!" << endl;
*/

/*____________________________    Clique Tests    ______________________________
  g.addEdge(10,12);
  g.addEdge(10,13);
  g.buildBipartite(10,14, 16,23);

  g.addEdge(11,12);
  g.addEdge(11,13);
  g.addEdge(11,14);
  g.addEdge(12,13);
  g.addEdge(12,14);
  g.addEdge(12,15);
  g.addEdge(13,14);
  g.addEdge(13,15);
  g.addEdge(14,15);

  g.buildClique(12,20);

  cerr << "MC:" << g.getMCEX() << endl;
*/

/*____________________________      MIS Tests     ______________________________
*/
//GRAPH from wikipedia: MC:0 2 4 6 21 23 9 28 30
  g.addEdge(0,1);
  g.addEdge(0,20);
  g.addEdge(1,2);
  g.addEdge(1,21);
  g.addEdge(2,3);
  g.addEdge(2,22);
  g.addEdge(3,4);
  g.addEdge(3,23);
  g.addEdge(4,5);
  g.addEdge(4,24);
  g.addEdge(5,6);
  g.addEdge(5,25);
  g.addEdge(5,6);
  g.addEdge(5,25);
  g.addEdge(6,7);
  g.addEdge(6,26);
  g.addEdge(7,8);
  g.addEdge(7,27);
  g.addEdge(8,9);
  g.addEdge(8,28);
  g.addEdge(9,10);
  g.addEdge(9,29);
  g.addEdge(10,11);
  g.addEdge(10,30);
  g.addEdge(11,0);
  g.addEdge(11,31);
  for(int j=20; j<24; j++)
    {
    g.addEdge(j, j+4);
    g.addEdge(j, j+8);
    g.addEdge(j+4, j+8);
    }
/*
//GRAPH bipartite:  MC:40 41 42 43 44 45
  g.buildBipartite(40,45, 46,49);
//GRAPH from mathworld:  MC:50 55 53 58 61
  g.addEdge(50,51);
  g.addEdge(50,57);
  g.addEdge(51,52);
  g.addEdge(51,58);
  g.addEdge(52,53);
  g.addEdge(52,58);
  g.addEdge(53,54);
  g.addEdge(53,59);
  g.addEdge(54,55);
  g.addEdge(54,59);
  g.addEdge(55,56);
  g.addEdge(55,60);
  g.addEdge(56,60);
  g.addEdge(56,50);
  g.addEdge(57,58);
  g.addEdge(57,61);
  g.addEdge(59,61);
  g.addEdge(60,61);
*/

  cout << g;
  cerr << "MC:" << g.getMISEX() << endl;
/*
  list<int> l = g.getNextMalIS();
  while(!l.empty())
    {
    cerr << "MalC:" << l << endl;
    l = g.getNextMalIS();
    }
*/

  return(0);
  }
